'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var testingProcess = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(counter) {
        var files, child, finishedResult, i, oneResult, _files, _child, _finishedResult, _i, _oneResult;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!program.f) {
                            _context.next = 34;
                            break;
                        }

                        if (!(program.f === 'all')) {
                            _context.next = 18;
                            break;
                        }

                        files = fs.readdirSync('./tests');
                        child = [];
                        finishedResult = [];
                        i = 0;

                    case 6:
                        if (!(i < files.length)) {
                            _context.next = 16;
                            break;
                        }

                        child.push(cp.fork('./child_process.js'));
                        _context.next = 10;
                        return sender(child[i], files[i], counter, 'tests');

                    case 10:
                        oneResult = _context.sent;


                        finishedResult.push(oneResult);
                        if (finishedResult.length === files.length) {
                            drawingTable(finishedResult);
                        }

                    case 13:
                        i++;
                        _context.next = 6;
                        break;

                    case 16:
                        _context.next = 32;
                        break;

                    case 18:
                        _files = fs.readdirSync('./' + process.argv[3]);
                        _child = [];
                        _finishedResult = [];
                        _i = 0;

                    case 22:
                        if (!(_i < _files.length)) {
                            _context.next = 32;
                            break;
                        }

                        _child.push(cp.fork('./child_process.js'));
                        _context.next = 26;
                        return sender(_child[_i], _files[_i], counter, process.argv[3]);

                    case 26:
                        _oneResult = _context.sent;

                        _finishedResult.push(_oneResult);

                        if (_finishedResult.length === _files.length) {
                            drawingTable(_finishedResult);
                        }

                    case 29:
                        _i++;
                        _context.next = 22;
                        break;

                    case 32:
                        _context.next = 35;
                        break;

                    case 34:
                        console.log('Command not found');

                    case 35:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function testingProcess(_x) {
        return _ref.apply(this, arguments);
    };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cp = require('child_process');
var fs = require('fs');
var program = require('commander');
var Table = require('cli-table2');

program.version('0.0.1').option('run, --f [type]', '').option('iter, --i [type]', '').parse(process.argv);

var counter = Number(program.i) || 1;
var startTestingTime = new Date();

function sender(child, file, counter, dirname) {
    return new _promise2.default(function (resolve, reject) {
        child.on('message', function (result) {
            resolve(result);
            child.kill();
        });
        child.send({ fileName: file, counter: counter, dirname: dirname });
    });
};

console.log('Time start testing: ' + startTestingTime.getDate() + '.' + startTestingTime.getMonth() + '.' + startTestingTime.getFullYear() + 'y   ' + startTestingTime.getHours() + ':' + startTestingTime.getMinutes() + ':' + startTestingTime.getSeconds());
console.log('Testing folder: ' + program.f);
console.log('Waiting...................');

function drawingTable(finishedResult) {
    var finishedTestingTime = new Date();
    var table = new Table({
        chars: { 'top': '═', 'top-mid': '╤', 'top-left': '╔', 'top-right': '╗',
            'bottom': '═', 'bottom-mid': '╧', 'bottom-left': '╚', 'bottom-right': '╝',
            'left': '║', 'left-mid': '╟', 'mid': '─', 'mid-mid': '┼',
            'right': '║', 'right-mid': '╢', 'middle': '│' }
    });
    table.push(["Tested files", "Time spent", "RSS", 'HEAP TOTAL', 'HEAP USED']);

    for (var i = 0; i < finishedResult.length; i++) {
        var description = finishedResult[i].description;
        var usedTime = finishedResult[i].time;
        var rss = finishedResult[i].memory.rss;
        var heapTotal = finishedResult[i].memory.heapTotal;
        var heapUsed = finishedResult[i].memory.heapUsed;

        table.push([description, usedTime + " ms", Math.round(rss / 1024 / 1024).toFixed(2) + ' MB', Math.round(heapTotal / 1024 / 1024).toFixed(2) + ' MB', Math.round(heapUsed / 1024 / 1024).toFixed(2) + ' MB']);
    };

    console.log('Time end testing: ' + finishedTestingTime.getDate() + '.' + finishedTestingTime.getMonth() + '.' + finishedTestingTime.getFullYear() + 'y   ' + finishedTestingTime.getHours() + ':' + finishedTestingTime.getMinutes() + ':' + finishedTestingTime.getSeconds());
    console.log('The results: ');
    console.log(table.toString());
}
testingProcess(counter);