let cp = require ('child_process');
let fs = require ('fs');
let program = require('commander');
let Table = require('cli-table2');

program
    .version('0.0.1')
    .option('run, --f [type]', '')
    .option('iter, --i [type]', '')
    .parse(process.argv);

let counter = Number(program.i) || 1;
let startTestingTime = new Date;

async function testingProcess (counter){
    if(program.f){
        if (program.f === 'all'){
            let files = fs.readdirSync ('./tests');
            let child = [];
            let finishedResult = [];

            for(let i=0; i<files.length; i++){
                child.push(cp.fork('./child_process.js'));
                let oneResult = await sender(child[i], files[i], counter, 'tests' );

                finishedResult.push(oneResult);
                if(finishedResult.length === files.length){
                    drawingTable(finishedResult);
                }
            }
        }
        else {
            let files = fs.readdirSync ('./'+process.argv[3]);

            let child = [];
            let finishedResult = [];

            for(let i=0; i<files.length; i++){
                child.push(cp.fork('./child_process.js'));
                let oneResult = await sender(child[i], files[i], counter, process.argv[3]);
                finishedResult.push(oneResult);

                if(finishedResult.length === files.length){
                    drawingTable(finishedResult);
                }
            }
        }
    }
    else {
        console.log('Command not found');
    }
}
function sender (child, file, counter, dirname){
    return new Promise(function (resolve, reject) {
        child.on('message', function (result){
            resolve(result);
            child.kill();
        });
        child.send({fileName:file, counter:counter, dirname:dirname});
    });
};

console.log('Time start testing: '+startTestingTime.getDate()+'.'+startTestingTime.getMonth()+'.'+startTestingTime.getFullYear()+'y   '+startTestingTime.getHours()+':'+startTestingTime.getMinutes()+':'+startTestingTime.getSeconds())
console.log('Testing folder: ' + program.f);
console.log('Waiting...................');

function drawingTable(finishedResult){
    let finishedTestingTime = new Date();
    let table = new Table({
        chars: { 'top': '═' , 'top-mid': '╤' , 'top-left': '╔' , 'top-right': '╗'
            , 'bottom': '═' , 'bottom-mid': '╧' , 'bottom-left': '╚' , 'bottom-right': '╝'
            , 'left': '║' , 'left-mid': '╟' , 'mid': '─' , 'mid-mid': '┼'
            , 'right': '║' , 'right-mid': '╢' , 'middle': '│' }
    });
    table.push(["Tested files", "Time spent", "RSS", 'HEAP TOTAL', 'HEAP USED'] );

    for (let i = 0; i<finishedResult.length; i++){
        let description = finishedResult[i].description;
        let usedTime = finishedResult[i].time;
        let rss = finishedResult[i].memory.rss;
        let heapTotal = finishedResult[i].memory.heapTotal;
        let heapUsed = finishedResult[i].memory.heapUsed;

        table.push(
             [description, usedTime+" ms",Math.round((rss/1024)/1024).toFixed(2)+' MB', Math.round((heapTotal/1024)/1024).toFixed(2)+' MB', Math.round((heapUsed/1024)/1024).toFixed(2)+' MB' ]
        );
    };

    console.log('Time end testing: '+finishedTestingTime.getDate()+'.'+finishedTestingTime.getMonth()+'.'+finishedTestingTime.getFullYear()+'y   '+finishedTestingTime.getHours()+':'+finishedTestingTime.getMinutes()+':'+finishedTestingTime.getSeconds())
    console.log('The results: ');
    console.log(table.toString());
}
testingProcess(counter);



